/* Time-stamp: <2005-05-07 17:37:33 >  */
#include  "midi_io.h"
#include  "signal_exit.h"
#include  "4ru.h"
/* #include  "GLcolors.h" */


extern  NOTE_NODE *note_top;
extern  NOTE_NODE *note_bot;
extern  NOTE_NODE *note_cur;
extern  NOTE_NODE *note_alc;
extern  NOTE_HEADER note_header_info;

extern NOTE_NODE *view_note_cur;

extern  EL *e_top;
extern  EL *e_bot;
extern  EL *e_cur;
extern  EL *e_alc;
extern  SMF_HEADER  smf_header;
extern  int midiin_port;
extern  int midiin_called;
extern  int midi_in_through;
extern  int midiout_port;
extern  int midinote_in;

extern int win_w;
extern int win_h;
extern int win_id;

extern char gttm_line[STR_LEN];
extern int gttm_exec;
extern EL *decide_dur[DECIDE_DUR_NUM];

extern int should_re_draw;

static double tempo_usec;



void RTgpr_body(int para)
{
  static int i;
/*   NOTE_NODE *srch; */

  para = para;

  if(midinote_in == ON){
    while(1){
      if(e_cur == NULL){  break; }
      if((e_cur->ident == NOTE) &&(e_cur->val2 != 0) ){
	e2note(e_cur, &note_cur, tempo_usec);
	strcpy(note_cur->str[1], RTGPR_NOTE_IDENT);
/* 	print_node(note_cur); */
	note_cur = note_cur->next;
	note_bot = note_cur;
      }
      if(e_cur == e_bot){
	break;
      }else{
	e_cur = e_cur->next;
      }
    }
    midinote_in = NOP;
    gttm_exec = ON;
    gttm(NULL);
    should_re_draw = ON;
  }else if(midinote_in == OFF){
    for(i = 0; i < DECIDE_DUR_NUM; i++){
      if(decide_dur[i] != NULL){
	if(decide_dur[i]->note_node != NULL){
	  e2note(decide_dur[i], &(decide_dur[i]->note_node), tempo_usec);
	  decide_dur[i] = NULL;
	}
      }
    }
    midinote_in = NOP;
    gttm_exec = ON;
    gttm(NULL);
    should_re_draw = ON;
  }
}

void RTgpr(int *argcp, char *argv[], char *filename)
{
  struct itimerval itval;
/*   int i; */

  filename = filename;

  init_note_header_info(&note_header_info);
  note_header_info.timescale = T_BEAT;

  pre_alloc();

  strcpy(gttm_line, RTGPR_NOTE_IDENT);

  signal(SIGTERM, signal_exit);
  signal(SIGINT, signal_exit);

  tempo_usec = 500000;
  itval.it_interval.tv_sec = 1;
  itval.it_interval.tv_usec = 0;
  itval.it_value.tv_sec = 1;
  itval.it_value.tv_usec = 0;
/*   signal(SIGVTALRM, RTgpr_body); */
/*   printf("ret: %d\n", setitimer(ITIMER_VIRTUAL, &itval, NULL)); */
/*   signal(SIGALRM, RTgpr_body); */
/*   printf("ret: %d\n", setitimer(ITIMER_REAL, &itval, NULL)); */
/*   printf("koko: %s\n", strerror(errno)); */

  nov_init(argcp, argv, "PredBound", NULL);
  glutMainLoop();

  return;
}
