/*  Time-stamp: <04/07/15 17:55:44 noike>  */
#include  "4ru.h"


int devi_keyline_make(NOTE_NODE *deviDB[DEVI_DB_SIZE], NOTE_NODE *devi_key[DEVI_DB_SIZE], int devifile_last,
		     char *keyident)
{
  NOTE_NODE *cur;
  NOTE_NODE *same;
  NOTE_NODE *key_cur;
  NOTE_NODE *pre;
  int i;

  for(i = 0; i < devifile_last; i++){
    devi_key[i] = NOTE_NODE_alloc();
    key_cur = devi_key[i];
    cur = deviDB[i];
    while(cur != NULL){
      same = cur;
      while(same != NULL){
	if( (same->ident == NOTE) || (same->ident == REST) ){
	  if(strcmp(same->str[1], keyident) == 0){
	    pre = key_cur->pre;
	    memcpy(key_cur, same, sizeof(NOTE_NODE));
	    key_cur->pre = pre;
	    key_cur->next = NOTE_NODE_alloc();
	    key_cur->next->pre = key_cur;
	    key_cur = key_cur->next;
	  }
	}
	same = same->samenext;
      }
      cur = cur->next;
    }

    if(key_cur->pre != NULL){
      key_cur = key_cur->pre;
    }
    free(key_cur->next);
    key_cur->next = NULL;
  }


#if 0
  for(i = 0; i < devifile_last; i++){
    cur = devi_key[i];
    while(cur != NULL){
      br_printf(4, "%s %5.3f\n", cur->str[0], cur->len.beat);
      cur = cur->next;
    }
    printf("-------- %d\n", i);
    getchar();
  }
#endif

  return EXIT_SUCCESS;
}

