/*  Time-stamp: <2004-12-13 17:57:50 >  */
#include  "4ru.h"
#include  <glut.h>


extern int disp_vel;


void disp_vel_value(double x, double y, double z, GLdouble colors[4], int vel)
{
  static int called = 0;
  static GLuint str_base;
  int i;
  char vel_str[STR_LEN];


  if(disp_vel != ON){
    return;
  }


  if(called == 0){
    called = 1;
    str_base = glGenLists(256);
    for(i = 0; i < 256; i++){
      glNewList(str_base + i, GL_COMPILE);
      glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, i);
/*       glutBitmapCharacter(GLUT_BITMAP_HELVETICA_12, i); */
      glEndList();
    }
  }

  glListBase(str_base);
  glColor4dv(colors);
  glRasterPos3d(x, y + 7, z);

  sprintf(vel_str, "%d", vel);
  glCallLists((GLint) strlen(vel_str), GL_BYTE, vel_str);

}

