#include  "NOTEfile.h"
#include  "disp_errline.h"


int note_memo_parse(FILE *fp, char *filename,
		    int line, char linebuf[], int *idx, char token[],
		    NOTE_NODE *cur)
{

  fp = fp;


  cur->ident = MEMO;

  get_token(linebuf, idx, token);
  if(strcmp(token, " ") != 0){
    disp_errline(filename, line, linebuf, *idx, "ʸʤ");
    fclose(fp);
    exit(EXIT_FAILURE);
  }

  get_token(linebuf, idx, token);   /*  ʸμ token   */

  if(strcmp(token, "") == 0){
    disp_errline(filename, line, linebuf, *idx, "ʸ󤬤ʤ");
    fclose(fp);
    exit(EXIT_FAILURE);
  }

  strcpy(cur->str[0], jcode_local(token));

  get_token(linebuf, idx, token);   /*  ʸμ token   */

  /*  ʸβ  */
  if(cur->str[0][0] == '/'){  /*  Boundary  */
    sscanf(cur->str[0], "/ %lf",  &(cur->val[0]));
  }

/*   printf("\nmemo: %s %5.3f\n", cur->str[0], cur->val[0]); */


  return EXIT_SUCCESS;
}
