/*  Time-stamp: <2004-04-27 05:28:37 >  */
#include  "NOTEfile.h"


int pedal_write(FILE **fp, NOTE_NODE *cur, WRITE_CTRL wctrl)
{
  switch(wctrl.out_note_format){
  case  NO_INFO:
  case  T_BEAT:  /*  TIMESCALE  BEAT ǽ񤭽Ф  */
    fprintf(*fp, "%*.*f ", wctrl.precision+3, wctrl.precision, cur->on_time.beat);
    break;

  case  T_REAL:
    fprintf(*fp, "%*.*f ", wctrl.precision+3, wctrl.precision, cur->on_time.real);
    break;

  case  T_DELTA:
    fprintf(*fp, "%d ", cur->on_time.delta);
    break;

  case  T_MEAS:
    fprintf(*fp, "%*.*f ", wctrl.precision+3, wctrl.precision, cur->on_time.meas);
    break;
  }


  switch(cur->ident){
  case  DAMPER:
    fprintf(*fp, " Damper  %d\n", (int)cur->val[0]);
    break;

  case  SOSTENUTO:
    fprintf(*fp, " Sostenuto  %d\n", (int)cur->val[0]);
    break;

  case  SOFT:
    fprintf(*fp, " Soft  %d\n", (int)cur->val[0]);
    break;

  default:
    br_printf(6, "%s: %d: ̤ΤΥڥǤ\n", __FILE__, __LINE__);
    break;
  }

  return EXIT_SUCCESS;
}
