/*  Time-stamp: <2005-08-08 13:40:43 >  */
#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>
#include  "4ru.h"
#ifndef stricmp
#include  "stricmp.h"
#endif


int notename_to_notenum(char *token, DRUM_DEF *drum_data)
{
  int i;
  int scale[7] = {
    9,  /*  A  */
    11, /*  B  */
    0,  /*  C  */
    2,  /*  D  */
    4,  /*  E  */
    5,  /*  F  */
    7   /*  G  */
  };
  int retval = 0;


  /*  ɥڴ͡फɤå  */
  if(drum_data != NULL){
    for(i = 0; i < DRUM_KIND; i++){
      if(strcmp(token, (*(drum_data + i)).str) == 0){
	return (*(drum_data + i)).note_no;
      }
    }
  }


  i = 0;
  switch(token[i]){
  case 'C':
  case 'D':
  case 'E':
  case 'F':
  case 'G':
  case 'A':
  case 'B':
    retval = scale[*(token + i) - 'A'];

    i++;

    /*  Ĵߤʤǡ硼ȴ  */
    if(strncmp(token + i, "#", 1) == 0){
      retval += 1;
      i++;
    }
    else if(strncmp(token + i, "bb", 2) == 0){
      retval -= 2;
      i += 2;
    }
    else if(strncmp(token + i, "b", 1) == 0){
      retval -= 1;
      i++;
    }
    else if(strncmp(token + i, "x", 1) == 0){
      retval += 2;
      i++;
    }

    retval += (((*(token + i) - '0') + 1) * 12);

    return retval;


  case  'R':
    if(stricmp(token, "Rest") == 0){
      retval = -1;
    }
    return retval;


  default:
    return retval;
  }
}
