/* Time-stamp: <2005-01-25 19:00:25 >  */
#include  "4ru.h"

/*  R^ vel J[u  */

extern NOTE_NODE *part_top[PART_NUM];
extern int part_num;


extern NOTE_HEADER note_header_info;
extern NOTE_NODE *note_top;  /*  part_top CNOTE t@Cp 1 {ɂ܂Ƃ߂Ƃ̐擪m[h  */
extern NOTE_NODE *note_bot;
/* extern NOTE_NODE *note_cur; */
extern NOTE_NODE *note_alc;

extern NOTE_NODE *view_note_cur;
extern NOTE_NODE *view_note_bot;


void rainbow_vel(char *start_words, char *apex_words, char *end_words, double top_amp)
{
  NOTE_NODE *cur;
  NOTE_NODE *same;
  NOTE_NODE *srch;
  NOTE_NODE *srch2;
  NOTE_NODE *srchcur;
  NOTE_NODE *gs;
  NOTE_NODE *ge;
  NOTE_NODE *ga;
  int part_i;
  int i;
  double time_int;
  double top_time;
  double base_amp;
  double slope;

  /*   for UNDO  */
  for(part_i = 0; part_i < part_num; part_i++){
    all_TFcopy(part_top[part_i]);
  }
  /*   for UNDO  */



/*   part_top ɑ΂ĕύXCŌ note_top 蒼 */

  base_amp = 1.0;

  printf("%s: Vel: %s(%3.2f) - %s(%3.2f) - %s(%3.2f)\n", __FILE__,
	    start_words, base_amp, apex_words, top_amp, end_words, base_amp);

  for(part_i = 0; part_i < part_num; part_i++){
    cur = part_top[part_i];
    while(cur != NULL){
      same = cur;
      while(same != NULL){
	if( (same->ident == WORDS) &&
	    (strcmp(same->str[0], start_words) == 0) ){
	  /* ==================================================================== */
	  /*  level 1 ̃O[v̏  */
	  gs = NULL;
	  ge = NULL;
	  ga = NULL;
	  srch = same;
	  /*  start NOTE node T  */
	  while(1){
	    if(srch == NULL){
	      disp_err("vel group start node not found.");
	      return;
	    }
	    if( (srch->ident == NOTE) && (eq(srch->on_time.beat, same->on_time.beat)) ){
	      gs = srch;
	      break;
	    }
	    srch = srch->next;
	  }

	  /*  end WORDS node T  */
	  while(1){
	    while(1){
	      if(srch == NULL){
		disp_err("vel group end node not found.");
		return;
	      }
	      if( (srch->ident == WORDS) && (strcmp(srch->str[0], end_words) == 0) ){
		srch2 = srch->next;
		break;
	      }
	      srch = srch->next;
	    }
	    /*  end NOTE node T  */
	    while(1){
	      if(srch2 == NULL){
		disp_err("vel group end node not found.");
		return;
	      }
	      if( (srch2->ident == NOTE) &&
		  (eq(srch2->on_time.beat, srch->on_time.beat)) ){
		ge = srch2;
		srch2 = srch2->next;
		break;
	      }
	      srch2 = srch2->next;
	    }
	    if(strcmp(ge->str[1], gs->str[1]) == 0){
	      break;
	    }
	    srch = srch->next;
	  }
	  
	  /*  apex WORD node T  */
	  srch = gs;
	  srch2 = NULL;
	  ga = NULL;
	  while(1){
	    while(1){
	      if(srch == ge){  break; }
	      if( (srch->ident == WORDS) && (strcmp(srch->str[0], apex_words) == 0) ){
		srch2 = srch->next;
		break;
	      }
	      srch = srch->next;
	    }
	    
	    while(1){
	      if(srch2 == NULL){  break; }
	      if(srch2 == ge){  break; }
	      if( (srch2->ident == NOTE) && (eq(srch2->on_time.beat, srch->on_time.beat)) ){
		ga = srch2;
		break;
	      }
	      srch2 = srch2->next;
	    }
	    if(strcmp(ga->str[1], gs->str[1]) == 0){
	      break;
	    }
	    srch = srch->next;
	  }

/* 	  if(ga != NULL){ */
/* 	    printf("------\n"); */
/* 	    print_node(gs); */
/* 	    print_node(ge); */
/* 	    print_node(ga); */
/* 	    printf("------\n\n"); */
/* 	  }else{ */
/* 	    br_printf(2, "ga is NULL\n"); */
/* 	  } */

	  /* ==================================================================== */
	  top_time = ga->on_time.beat;
	  time_int = ge->on_time.beat - gs->on_time.beat;
/* 	  printf("top_time: %5.3f, time_int: %5.3f\n", top_time, time_int); */
	  srchcur = gs;
	  while(1){
	    if(srchcur == NULL){
	      printf("NULL\n");
	      break;
	    }
	    if(strcmp(srchcur->str[1], gs->str[1]) != 0){
	      srchcur = srchcur->next;
	      continue;
	    }
	    if(srchcur->on_time.beat <= top_time){
	      /*   */
	      slope = (top_amp - base_amp) / (top_time - gs->on_time.beat);
	      srchcur->val[ON_VEL] =
		srchcur->val[ON_VEL] *
		(slope * (srchcur->on_time.beat - gs->on_time.beat) + base_amp);

/* 	      print_node(srchcur); */
	    }else{
	      /*   */
	      slope = (top_amp - base_amp) / (ge->on_time.beat - top_time);
	      srchcur->val[ON_VEL] =
		srchcur->val[ON_VEL] *
		((-1 * slope * (srchcur->on_time.beat - top_time)) + top_amp);
	    }
	    if(srchcur->val[ON_VEL] > 127){
	      srchcur->val[ON_VEL] = 127;
	    }else if(srchcur->val[ON_VEL] < 1){
	      srchcur->val[ON_VEL] = 1;
	    }

	    if(srchcur == ge){
	      break;
	    }
	    srchcur = srchcur->next;
	  }
	}
	same = same->samenext;
      }

      if(note_bot != NULL){
	if(cur == note_bot){
	  view_note_bot = cur;
	  break;
	}
      }
      cur = cur->next;
    }
  }


  /* part_top ւ̕ύX note_top ɔf */
  NOTE_list_free(note_top);

  note_header_info.timescale = T_BEAT;
  for(i = 0; i < PART_NUM; i++){
    note_time_consistency(part_top[i], &note_header_info);
  }
  note_top = part_merge(part_top, part_num);
/*   note_top = note_make_Ttree(note_top, &note_header_info); */

  view_note_cur = note_top;
}
