#include  "xml2note.h"


int velocity_apply(NOTE_NODE *part_top[PART_NUM], int part_num, int default_vel[PART_NUM])
{
  NOTE_NODE *part_cur;
  int now_vel[PART_NUM];
  int part_idx;

  for(part_idx = 0; part_idx < PART_NUM; part_idx++){
    now_vel[part_idx] = default_vel[part_idx];
  }

  for(part_idx = 0; part_idx < part_num; part_idx++){
    part_cur = part_top[part_idx];
    while(part_cur != NULL){
      if(part_cur->ident == DYNAMICS){
	now_vel[part_cur->staff] = part_cur->val[0];
      }

      if( (part_cur->ident == NOTE) ||
	  (part_cur->ident == REST) ){
	if(xmlGetProp(part_cur->xmlnode, "dynamics") == NULL){
/* 	  part_cur->val[1] = now_vel[part_cur->staff - 1]; */
/* 	  part_cur->val[1] = now_vel[part_cur->voice - 1]; */
	  part_cur->val[1] = now_vel[part_idx];
	}
      }
      if(part_cur->next == NULL){
	break;
      }
      part_cur = part_cur->next;
    }
  }
  
 return 0;
}

