/*
MS-DOS, UNIX OS peLXgʐ֐W  Ver.1.90
    Programmed by Kenzi NOIKE
*/

#include  <stdio.h>
#include  <stdlib.h>
#include  <stdarg.h>
#include  <string.h>
#ifdef NEWS
#include  "Nstdio.h"
#include  "Nstdarg.h"
#endif
#include  "disp_ctr.h"


#ifdef __BORLANDC__
#include    <conio.h>
#endif


#define		SCR_END		1024
#define		LEN         10
#define         FORMAT_BUF_LEN  1024


#define BLACK   30  /*    	    30 */
#define BLUE    34  /*            34 */
#define RED     31  /*            31 */
#define MAGENTA 35  /*            35 */
#define GREEN   32  /*            32 */
#define CYAN    36  /*  F        36 */
#define YELLOW  33  /*  F        33 */
#define WHITE   37  /*            37 */
#define SECRET  16  /*	V[Nbg 8 */

#ifndef UNIX
/*   MS-DOS (MIEL Ŕf)reverse, blink ̒l`  */
#else

#endif


/*	J[\\[h	*/

int cursor_off(void)
{
    return( printf("\%c[>5h", ESC) );
}


/*	J[\\[h		*/

int cursor_on(void)
{
    return( printf("\%c[>5l", ESC) );
}


/*	t@NVL[\[h	*/

int fk_off(void)
{
        return( printf("\%c[>1h\n", ESC) );
}


/*	t@NVL[\[h	*/

int fk_on(void)
{
        return( printf("\%c[>1l\n", ESC) );
}


/*	J[\ʒu x, y Ƃ̕\Z[uB	*/

int save_xy_attr(void)
{
	return( printf("\%c[S", ESC) );
}


/*	save_xy_attr() ŃZ[ue߂BBsave_xy_attr() sĂȂƂ́AJ[\̓z[ɈړA͋KlɂȂB	*/

int restore(void)
{
	return( printf("\%c[U", ESC) );
}


/*	pOtBbN\[h	*/

int graph_char_on(void)
{
	return( printf("\%c)3", ESC) );
}


/*	[hBKlB	*/

int graph_char_off(void)
{
	return( printf("\%c)0", ESC) );
}


/*	sԋ	*/

int spacing_on(void)
{
	return( printf("\%c[>3h", ESC) );
}


/*	sԋl	*/

int spacing_off(void)
{
	return( printf("\%c[>3l", ESC) );
}


int color(int num)
{
    switch(num){
    case   -1:  return( printf("\%c[m", ESC) ); /*  K̑ɖ߂*/
    case    0:  return( printf("\%c[%dm", ESC, BLACK) );   /*    	*/
    case    1:  return( printf("\%c[%dm", ESC, BLUE) );    /*     34 */
    case    2:  return( printf("\%c[%dm", ESC, RED) );     /*     31 */
    case    3:  return( printf("\%c[%dm", ESC, MAGENTA) ); /*     35 */
    case    4:  return( printf("\%c[%dm", ESC, GREEN) );   /*     32 */
    case    5:  return( printf("\%c[%dm", ESC, CYAN) );    /*  F 36 */
    case    6:  return( printf("\%c[%dm", ESC, YELLOW) );  /*  F 33 */
    case    7:  return( printf("\%c[30m", ESC) );   /*     37 */
    case	127:return( printf("\%c[%dm", ESC, SECRET) );  /*  V[Nbg 8 */
    default  :  return( printf("\%c[m", ESC) ); /*  K̑ɖ߂*/
    }
}


int color_s(int num, char *buf)
{
#if 0
	if((num >= 8) && (num != 127)){	/*  127 ̏͂ƂŁAƂB*/
    	char *buf_top;
    	buf_top = buf;
        sprintf(buf, "%s",  "\%c[7m", ESC);
        buf = buf_top;
        num -= 8;
    }
#endif

    switch(num){
	  case    0:
		return( sprintf(buf, "\%c[%dm", ESC, BLACK) );   /*     30 */
	  case    1:
		return( sprintf(buf, "\%c[%dm", ESC, BLUE) );    /*     34 */
	  case    2:
		return( sprintf(buf, "\%c[%dm", ESC, RED) );     /*     31 */
	  case    3:
		return( sprintf(buf, "\%c[%dm", ESC, MAGENTA) ); /*     35 */
	  case    4:
		return( sprintf(buf, "\%c[%dm", ESC, GREEN) );   /*     32 */
	  case    5:
		return( sprintf(buf, "\%c[%dm", ESC, CYAN) );    /*  F 36 */
	  case    6:
		return( sprintf(buf, "\%c[%dm", ESC, YELLOW) );  /*  F 33 */
	  case    7:
		return( sprintf(buf, "\%c[%dm", ESC, WHITE) );   /*     37 */
	  case	127:
		return( sprintf(buf, "\%c[%dm", ESC, SECRET) );	/*	V[Nbg 8 */
	  default  :
		return( sprintf(buf, "\%c[m", ESC) ); /*  K̑ɖ߂*/
    }
}


int reverse(void)
{
	return( printf("\%c[7m", ESC) );
}

/*  br() 쐬߁Cp~D
    ԂCbr() ́CS OS ʂƎvD
    p~ŔCCygwin Bash Shell ̐F̐U镑ɍ킹āC
    炽ȃJ[ԍ` br() ̂ŁDƂ̍邽߁D

    p~́C߁D
    wrapping 邱ƂɂD
*/
char *r_color(int num)
{
  return br(num);
}
  
#if 0
#if defined(UNIX)
int r_color(int num)
{
    switch(num){
        case    0:  return( printf("\%c[40m", ESC) ); /*     30 */
        case    1:  return( printf("\%c[44m", ESC) ); /*     34 */
        case    2:  return( printf("\%c[41m", ESC) ); /*     31 */
        case    3:  return( printf("\%c[45m", ESC) ); /*     35 */
        case    4:  return( printf("\%c[42m", ESC) ); /*     32 */
        case    5:  return( printf("\%c[46m", ESC) ); /*  F 36 */
        case    6:  return( printf("\%c[43m", ESC) ); /*  F 33 */
        case    7:  return( printf("\%c[47m", ESC) ); /*     37 */
		case	127:return( printf("\%c[7;16m", ESC) );	/*	V[Nbg 8 */
        default  :  return( printf("\%c[m", ESC) ); /*  K̑ɖ߂*/
    }
}
#elif defined(MSDOS)
/*  for MS-DOS environment(MIEL Ŕf)  */
int r_color(int num)
{
    switch(num){
        case    0:  return( printf("\%c[7;30m", ESC) ); /*     30 */
        case    1:  return( printf("\%c[7;34m", ESC) ); /*     34 */
        case    2:  return( printf("\%c[7;31m", ESC) ); /*     31 */
        case    3:  return( printf("\%c[7;35m", ESC) ); /*     35 */
        case    4:  return( printf("\%c[7;32m", ESC) ); /*     32 */
        case    5:  return( printf("\%c[7;36m", ESC) ); /*  F 36 */
        case    6:  return( printf("\%c[7;33m", ESC) ); /*  F 33 */
        case    7:  return( printf("\%c[7;37m", ESC) ); /*     37 */
		case	127:return( printf("\%c[7;16m", ESC) );	/*	V[Nbg 8 */
        default  :  return( printf("\%c[m", ESC) ); /*  K̑ɖ߂*/
    }
}
#elif defined(__BORLANDC__)
int r_color(int num)
{
    switch(num){
        case    0: /*     30 */
	  textbackground(BLACK);
	  break;

        case    1: /*     34 */
	  textbackground(BLUE);
	  break;

        case    2: /*     31 */
	  textbackground(RED);
	  break;

        case    3: /*     35 */
	  textbackground(MAGENTA);
	  break;
	  
        case    4: /*     32 */
	  textbackground(GREEN);
	  break;

        case    5: /*  F 36 */
	  textbackground(CYAN);
	  break;

        case    6: /*  F 33 */
	  textbackground(YELLOW);
	  break;

        case    7: /*     37 */
	  textbackground(WHITE);
	  break;

	case	127:	/*	V[Nbg 8 */
	  textbackground(BLACK);
	  break;

        default  : /*  K̑ɖ߂*/
	  textbackground(BLACK);  /*  K̑łƂ͌Ȃ̂ŁCƂŒ  */
	  break;

    }

    return 1;

}
#endif
#endif


int blink(void)
{
	return( printf("\%c[5m", ESC) );
}


int b_color(int num)
{
    switch(num){
        case    0:  return( printf("\%c[5;30m", ESC) ); /*     34 */
        case    1:  return( printf("\%c[5;34m", ESC) ); /*     34 */
        case    2:  return( printf("\%c[5;31m", ESC) ); /*     31 */
        case    3:  return( printf("\%c[5;35m", ESC) ); /*     35 */
        case    4:  return( printf("\%c[5;32m", ESC) ); /*     32 */
        case    5:  return( printf("\%c[5;36m", ESC) ); /*  F 36 */
        case    6:  return( printf("\%c[5;33m", ESC) ); /*  F 33 */
        case    7:  return( printf("\%c[5;37m", ESC) ); /*     37 */
		case	127:return( printf("\%c[5;16m", ESC) );	/*	V[Nbg 8 */
        default  :  return( printf("\%c[m", ESC) ); /*  K̑ɖ߂*/
    }
}


int blirev(void)
{
	return( printf("\%c[5;7m", ESC) );
}


int br_color(int num)
{
    switch(num){
        case    0:  return( printf("\%c[5;7;30m", ESC) ); /*    */
        case    1:  return( printf("\%c[5;7;34m", ESC) ); /*    */
        case    2:  return( printf("\%c[5;7;31m", ESC) ); /*    */
        case    3:  return( printf("\%c[5;7;35m", ESC) ); /*    */
        case    4:  return( printf("\%c[5;7;32m", ESC) ); /*    */
        case    5:  return( printf("\%c[5;7;36m", ESC) ); /*  F*/
        case    6:  return( printf("\%c[5;7;33m", ESC) ); /*  F*/
        case    7:  return( printf("\%c[5;7;37m", ESC) ); /*    */
		case	127:return( printf("\%c[5;7;16m", ESC) ); /*  V[Nbg 8 */
        default  :  return( printf("\%c[m", ESC) ); /*  K̑ɖ߂*/
    }
}


int xy(int x, int y)
{
    return( printf("\%c[%d;%dH", ESC, y, x) );
}


int c_printf(int c, char *format, ...)
{
    int ret;
    va_list argptr;
    char new_format[FORMAT_BUF_LEN];
    char first_nl[FORMAT_BUF_LEN];
    char last_nl[FORMAT_BUF_LEN];

    
    va_start(argptr, format);

    first_last_nl_chk(format, first_nl, new_format, last_nl);

    color(-1);
    printf(first_nl);

    color(c);
    ret = vprintf(new_format, argptr);

    color(-1);
    printf(last_nl);

    va_end(argptr);

    color(-1);
	
    return( ret );
}


#define  rc_printf  br_printf

#if 0
int rc_printf(int c, char *format, ...)
{
    int ret;
    va_list argptr;
    char new_format[FORMAT_BUF_LEN];
    char first_nl[FORMAT_BUF_LEN];
    char last_nl[FORMAT_BUF_LEN];

    
    va_start(argptr, format);
    first_last_nl_chk(format, first_nl, new_format, last_nl);
    

#if defined(UNIX)
    r_color(-1);
    printf(first_nl);

    r_color(c);
    ret = vprintf(new_format, argptr);

    r_color(-1);
    printf(last_nl);

#elif defined(__BORLANDC__)
    ret = vprintf(format, argptr);
    /*    ret = cprintf("hohoho");  */
#endif

    va_end(argptr);
    r_color(-1);

    return( ret );
}
#endif


int bc_printf(int c, char *format, ...)
{
    int ret;
    va_list argptr;
    char new_format[FORMAT_BUF_LEN];
    char first_nl[FORMAT_BUF_LEN];
    char last_nl[FORMAT_BUF_LEN];

    
    va_start(argptr, format);
    first_last_nl_chk(format, first_nl, new_format, last_nl);

    b_color(-1);
    printf(first_nl);

    b_color(c);
    ret = vprintf(new_format, argptr);

    b_color(-1);
    printf(last_nl);

    va_end(argptr);
    b_color(-1);

    return( ret );
}


int brc_printf(int c, char *format, ...)
{
    int ret;
    va_list argptr;
    char new_format[FORMAT_BUF_LEN];
    char first_nl[FORMAT_BUF_LEN];
    char last_nl[FORMAT_BUF_LEN];

    
    va_start(argptr, format);
    first_last_nl_chk(format, first_nl, new_format, last_nl);

    br_color(-1);
    printf(first_nl);

    br_color(c);
    ret = vprintf(new_format, argptr);

    br_color(-1);
    printf(last_nl);

    va_end(argptr);

    return( ret );
}


int x_printf(int x, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    left(SCR_END);
    right(x);
    ret = vprintf(format, argptr);
    va_end(argptr);

    return( ret );
}


int xc_printf(int x, int c, char *format, ...)
{
    int ret;
    va_list argptr;
    char new_format[FORMAT_BUF_LEN];
    char first_nl[FORMAT_BUF_LEN];
    char last_nl[FORMAT_BUF_LEN];
    
    va_start(argptr, format);
    left(SCR_END);
    right(x);

    first_last_nl_chk(format, first_nl, new_format, last_nl);

    color(-1);
    printf(first_nl);

    color(c);
    ret = vprintf(format, argptr);

    color(-1);
    printf(last_nl);

    va_end(argptr);

    return( ret );
}


int xrc_printf(int x, int c, char *format, ...)
{
    int ret;
    va_list argptr;
    char new_format[FORMAT_BUF_LEN];
    char first_nl[FORMAT_BUF_LEN];
    char last_nl[FORMAT_BUF_LEN];
    
    va_start(argptr, format);
    left(SCR_END);
    right(x);

    first_last_nl_chk(format, first_nl, new_format, last_nl);

    r_color(-1);
    printf(first_nl);

    r_color(c);
    ret = vprintf(new_format, argptr);

    r_color(-1);
    printf(last_nl);

    /*  koko  */

    va_end(argptr);

    return( ret );
}


int xbc_printf(int x, int c, char *format, ...)
{
    int ret;

    left(SCR_END);
    right(x);

    ret = bc_printf(c, format);
    
    return( ret );
}


int xbrc_printf(int x, int c, char *format, ...)
{
    int ret;


    left(SCR_END);
    right(x);

    ret = brc_printf(c, format);
    
    return( ret );
}


int y_printf(int y, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    up_no_scroll(SCR_END);
    down(y);

    ret = vprintf(format, argptr);

    va_end(argptr);
    
    return( ret );
}


int yc_printf(int y, int c, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    up_no_scroll(SCR_END);
    down(y);

    ret = c_printf(c, format);
    
    return( ret );
}


int yrc_printf(int y, int c, char *format, ...)
{
    int ret;

    
    up_no_scroll(SCR_END);
    down(y);

    ret = rc_printf(c, format);
    
    return( ret );
}


int ybc_printf(int y, int c, char *format, ...)
{
    int ret;

    
    up_no_scroll(SCR_END);
    down(y);

    ret = bc_printf(c, format);
    
    return( ret );
}


int ybrc_printf(int y, int c, char *format, ...)
{
    int ret;

    up_no_scroll(SCR_END);
    down(y);
    ret = brc_printf(c, format);
    
    return( ret );
}


int xy_printf(int x, int y, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    xy(x, y);
    ret = vprintf(format, argptr);
    va_end(argptr);
    
    return( ret );
}


int xyc_printf(int x, int y, int c, char *format, ...)
{
    int ret;
    va_list argptr;
    char new_format[FORMAT_BUF_LEN];
    char first_nl[FORMAT_BUF_LEN];
    char last_nl[FORMAT_BUF_LEN];
    
    va_start(argptr, format);
    /*  koko2  */

    first_last_nl_chk(format, first_nl, new_format, last_nl);
    
    xy(x, y);

    color(-1);
    printf(first_nl);

    color(c);
    ret = vprintf(format, argptr);
    
    color(-1);
    printf(last_nl);

    va_end(argptr);
    
    return( ret );
}


int xyrc_printf(int x, int y, int c, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    xy(x, y);
    r_color(c);
    ret = vprintf(format, argptr);
    va_end(argptr);
	color(-1);
    
    return( ret );
}


int xybc_printf(int x, int y, int c, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    xy(x, y);
    b_color(c);
    ret = vprintf(format, argptr);
    va_end(argptr);
	b_color(-1);

    return( ret );
}


int xybrc_printf(int x, int y, int c, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    xy(x, y);
    br_color(c);
    ret = vprintf(format, argptr);
    va_end(argptr);
	br_color(-1);
    
    return( ret );
}


/*	vscanf ֐ NEWS OS ɂȂI	*/

#ifdef CYGWIN
int c_scanf(int c, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    color(c);
    ret = vscanf(format, argptr);
    va_end(argptr);
	color(-1);
    
    return( ret );
}


int rc_scanf(int c, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    r_color(c);
    ret = vscanf(format, argptr);
    va_end(argptr);
	r_color(-1);
    
    return( ret );
}


int bc_scanf(int c, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    b_color(c);
    ret = vscanf(format, argptr);
    va_end(argptr);
	b_color(-1);
    
    return( ret );
}


int brc_scanf(int c, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    br_color(c);
    ret = vscanf(format, argptr);
    va_end(argptr);
	br_color(-1);
    
    return( ret );
}


int x_scanf(int x, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
	left(SCR_END);
	right(x);
    ret = vscanf(format, argptr);
    va_end(argptr);
    
    return( ret );
}


int xc_scanf(int x, int c, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
	left(SCR_END);
	right(x);
	color(c);
    ret = vscanf(format, argptr);
    va_end(argptr);
    
    return( ret );
}


int xrc_scanf(int x, int c, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
	left(SCR_END);
	right(x);
	r_color(c);
    ret = vscanf(format, argptr);
    va_end(argptr);
	r_color(-1);
    
    return( ret );
}


int xbc_scanf(int x, int c, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
	left(SCR_END);
	right(x);
	b_color(c);
    ret = vscanf(format, argptr);
    va_end(argptr);
	b_color(-1);
    
    return( ret );
}


int xbrc_scanf(int x, int c, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
	left(SCR_END);
	right(x);
	br_color(c);
    ret = vscanf(format, argptr);
    va_end(argptr);
	br_color(-1);
    
    return( ret );
}


int y_scanf(int y, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
	up_no_scroll(SCR_END);
	down(y);
    ret = vscanf(format, argptr);
    va_end(argptr);
    
    return( ret );
}


int yc_scanf(int y, int c, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
	up_no_scroll(SCR_END);
	down(y);
	color(c);
    ret = vscanf(format, argptr);
    va_end(argptr);
	color(-1);
    
    return( ret );
}


int yrc_scanf(int y, int c, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
	up_no_scroll(SCR_END);
	down(y);
	r_color(c);
    ret = vscanf(format, argptr);
    va_end(argptr);
	r_color(-1);
    
    return( ret );
}


int ybc_scanf(int y, int c, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
	up_no_scroll(SCR_END);
	down(y);
	b_color(c);
    ret = vscanf(format, argptr);
    va_end(argptr);
	b_color(-1);
    
    return( ret );
}


int ybrc_scanf(int y, int c, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
	up_no_scroll(SCR_END);
	down(y);
	br_color(c);
    ret = vscanf(format, argptr);
    va_end(argptr);
	br_color(-1);
    
    return( ret );
}


int xy_scanf(int x, int y, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    xy(x, y);
    ret = vscanf(format, argptr);
    va_end(argptr);
    
    return( ret );
}


int xyc_scanf(int x, int y, int c, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    xy(x, y);
    color(c);
    ret = vscanf(format, argptr);
    va_end(argptr);
	color(-1);
    
    return( ret );
}


int xyrc_scanf(int x, int y, int c, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    xy(x, y);
    r_color(c);
    ret = vscanf(format, argptr);
    va_end(argptr);
	r_color(-1);
    
    return( ret );
}


int xybc_scanf(int x, int y, int c, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    xy(x, y);
    b_color(c);
    ret = vscanf(format, argptr);
    va_end(argptr);
	b_color(-1);
    
    return( ret );
}


int xybrc_scanf(int x, int y, int c, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    xy(x, y);
    br_color(c);
    ret = vscanf(format, argptr);
    va_end(argptr);
	br_color(-1);
    
    return( ret );
}


#endif


/*	J[\ʒuE[܂ł	*/

int clr_to_right(void)
{
	return( printf("\%c[0K", ESC) );
}


/*	ݍs̍W x E[܂ł	*/

int x_clr_to_right(int x)
{
	left(SCR_END);
	right(x);
	return( clr_to_right() );
}


/*	ݍs̑΍W x E[܂ł	*/

int rel_x_clr_to_right(int x)
{
	rel_x(x);
	return( clr_to_right() );
}


/*	W x, y E[܂ł	*/

int xy_clr_to_right(int x, int y)
{
	xy(x, y);
	return( clr_to_right() );
}


/*	J[\ʒu獶[܂ł	*/

int clr_to_left(void)
{
	return( printf("\%c[1K", ESC) );
}


/*	W x, y 獶[܂ł	*/

int xy_clr_to_left(int x, int y)
{
	xy(x, y);
	return( clr_to_left() );
}


/*	ݍs̍W x 獶[܂ł	*/

int x_clr_to_left(int x)
{
	left(SCR_END);
	right(x);
	return( clr_to_left() );
}


/*	ݍs̑΍W x 獶[܂ł	*/

int rel_x_clr_to_left(int x)
{
	rel_x(x);
	return( clr_to_left() );
}


/*	J[\ʒu̍s	*/

int clr_line(void)
{
    return( printf("\%c[2K", ESC) );
}


/*	W y ̍s	*/

int y_clr_line(int y)
{
    int ret;
    
	xy(1, y);
    ret = clr_line();
    xy(1, y);
    
    return( ret );
}


/*	W x, y ̍s	*/

int xy_clr_line(int x, int y)
{
    int ret;
    
    xy(x, y);
    ret = clr_line();
    xy(x, y);
    
    return( ret );
}


/*	eLXgʏ(ESC *  98 L炵̂ŁAɒ)	*/

int cls(void)
{
    return( printf("\%c[2J", ESC) );
}


/*	ys s ye s܂ł	*/

void clr_w_y(int ys, int ye)
{
    int	i;
	
	for(i = ys; i <= ye; i++){
		xy(1, i);
		clr_line();
	}
}


void clr_w_x(int xs, int xe)
{
	char	spc[SCR_END];
	int		i;
	
	for(i = 0; i <= (xe - xs); i++){
		spc[i] = ' ';
	}
	spc[i] = '\0';
	
	for(i = 1; i < SCR_END; i++){
		xy_puts(xs, i, spc);
	}
	
/*	window(xs, 1, xe, 25);
	clrscr();
	window(1, 1, 80, 25);	*/
}


void clr_w_xy(int left, int top, int right, int bottom)
{
	char	spc[SCR_END];
	int		i;
	
	for(i = 0; i <= (right - left); i++){
		spc[i] = ' ';
	}
	spc[i] = '\0';
	
	for(i = top; i <= bottom; i++){
		xy_puts(left, i, spc);
	}
	
/*	window(left, top, right, bottom);
	clrscr();
	window(1, 1, 80, 25);	*/
}


/*	GXP[v܂񂾃t@CƂȂǂɂǂ	*/

/*	fp = stdout -> Wo										*/
/*	fp = strprn -> v^										*/
/*	fp = (nul t@Cւ̃|C^) -> \[h				*/
/*	ƂɁAo͐ȒPɐ؂ւƂȂǂɂǂ	*/

int c_fprintf(int c, FILE *fp, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    color(c);
    ret = vfprintf(fp, format, argptr);
    va_end(argptr);
	color(-1);

    return( ret );
}


int rc_fprintf(int c, FILE *fp, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    r_color(c);
    ret = vfprintf(fp, format, argptr);
    va_end(argptr);
	r_color(-1);

    return( ret );
}


int bc_fprintf(int c, FILE *fp, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    b_color(c);
    ret = vfprintf(fp, format, argptr);
    va_end(argptr);
	b_color(-1);

    return( ret );
}


int brc_fprintf(int c, FILE *fp, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    br_color(c);
    ret = vfprintf(fp, format, argptr);
    va_end(argptr);
	br_color(-1);

    return( ret );
}


int xy_fprintf(int x, int y, FILE *fp, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    xy(x, y);
    ret = vfprintf(fp, format, argptr);
    va_end(argptr);
    
    return( ret );
}


int xyc_fprintf(int x, int y, int c, FILE *fp, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    xy(x, y);
    color(c);
    ret = vfprintf(fp, format, argptr);
    va_end(argptr);
	color(-1);
    
    return( ret );
}


int xyrc_fprintf(int x, int y, int c, FILE *fp, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    xy(x, y);
    r_color(c);
    ret = vfprintf(fp, format, argptr);
    va_end(argptr);
	r_color(-1);
    
    return( ret );
}


int xybc_fprintf(int x, int y, int c, FILE *fp, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    xy(x, y);
    b_color(c);
    ret = vfprintf(fp, format, argptr);
    va_end(argptr);
	b_color(-1);

    return( ret );
}


int xybrc_fprintf(int x, int y, int c, FILE *fp, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    xy(x, y);
    br_color(c);
    ret = vfprintf(fp, format, argptr);
    va_end(argptr);
	br_color(-1);
    
    return( ret );
}


int c_sprintf(int c, char *buf, char *format, ...)
{
    int ret;
    va_list argptr;
	char tmpbuf[128];
    
    va_start(argptr, format);
    color_s(c, tmpbuf);
    ret = vsprintf(buf, format, argptr);
    va_end(argptr);
	strcat(buf, tmpbuf);
	color_s(-1, tmpbuf);
	strcat(buf, tmpbuf);

    return( ret );
}


/*	J[\̂s牺 l s폜Aȍ~̍sɋl߂B
	J[\ʒu͋l߂ꂽs̍[ɂȂB
	ŏIs𒴂Ă̍폜͍sȂB
	l = 0  l = 1 ƓlɏB */

int del_line(int l)
{
	return( printf("\%c[%dM", ESC, l) );
}


int xy_del_line(int x, int y, int l)
{
	xy(x, y);
	return( del_line(l) );
}


/*	J[\̍sȍ~ l sɈړA󔒂 l s}B
	J[\͐擪̑}s̍[ɈړB
	}sŏIs𒴂AړsŏIs𒴂ꍇ́A
	̒s͎Bl = 0 -> l = 1B  */

int ins_line(int l)
{
	return( printf("\%c[%dL", ESC, l) );
}


int xy_ins_line(int x, int y, int l)
{
	xy(x, y);
	return( ins_line(l) );
}


/*	J[\ y sɈړB
	ŏsw肵ĂAXN[ȂB
	y = 0 -> y = 1  */

int up_no_scroll(int y)
{
	return( printf("\%c[%dA", ESC, y) );
}


/*	J[\ y sɈړB
	ŉs艺w肵ĂAXN[ȂB
	y = 0 -> y = 1  */

int down_no_scroll(int y)
{
	return( printf("\%c[%dB", ESC, y) );
}


/*  x EֈړBE[łƂ܂Bx = 0 -> x = 1  */

int right(int x)
{
	return( printf("\%c[%dC", ESC, x) );
}


/*  x ֈړB[łƂ܂Bx = 0 -> x = 1  */

int left(int x)
{
	return( printf("\%c[%dD", ESC, x) );
}


/*	E܂łBJ[\ʒu͂̂܂܁B	*/
int clr_to_right_bottom(void)
{
	return( printf("\%c[0J", ESC) );
}


int xy_clr_to_right_bottom(int x, int y)
{
	xy(x, y);
	return( clr_to_right_bottom() );
}


/*  J[\ʒu獶܂łBJ[\ʒu͂̂܂܁B	*/
int clr_to_left_top(void)
{
	return( printf("\%c[1J", ESC) );
}


/*  J[\ 1 sɈړBŏIsɂƂ 1 sXN[AbvB
	𗘗pċtXN[łB*/

int one_down(void)
{
	return( printf("\%cD", ESC) );
}


/*	J[\ 1 s̍[ɈړBJ[\ŉsɂƂ́A
	XN[AbvB */
	
int one_down_left_end(void)
{
	return( printf("\%cE", ESC) );
}


/*	J[\ 1 sɈړB
	J[\擪sɂƂ 1 sXN[_EB  */

int one_up(void)
{
	return( printf("\%cM", ESC) );
}


int up(int y)
{
	int i, ret = 0;
	
	for(i = 0; i < y; i++){
		one_up();
		ret++;
	}
	
	return ret;
}


int down(int y)
{
	int i, ret = 0;
	
	for(i = 0; i < y; i++){
		one_down();
		ret++;
	}
	
	return ret;
}


int rel_y(int y)
{
  int i, ret = 0;
  
  for(i = 0; i < y; i++){
    one_down();
    ret++;
  }
  
  for(i = 0; i > y; i--){
    one_up();
    ret++;
  }
  
  return ret;
}


int rel_xy(int x, int y)
{
	int i, ret = 0;
	
	for(i = 0; i < y; i++){
		one_down();
		ret++;
	}
	
	for(i = 0; i > y; i--){
		one_up();
		ret++;
	}
	
	if(x > 0){
		right(x);
		ret++;
	}
	else if(x < 0){
		left(0 - x);
		ret++;
	}
	
	return ret;
}


int rel_x(int x)
{
	int ret = 0;
	
	if(x > 0){
		right(x);
		ret++;
	}
	else{
		left(0 - x);
		ret++;
	}
	
	return ret;
}
	

int rel_xy_printf(int x, int y, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    rel_xy(x, y);
    ret = vprintf(format, argptr);
    va_end(argptr);
    
    return( ret );
}


int rel_xyc_printf(int x, int y, int c, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    rel_xy(x, y);
    color(c);
    ret = vprintf(format, argptr);
    va_end(argptr);
    
	color( -1 );
    return( ret );
}


int rel_xyrc_printf(int x, int y, int c, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    rel_xy(x, y);
    r_color(c);
    ret = vprintf(format, argptr);
    va_end(argptr);
	r_color( -1 );

    return( ret );
}


int rel_xybc_printf(int x, int y, int c, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    rel_xy(x, y);
    b_color(c);
    ret = vprintf(format, argptr);
    va_end(argptr);
	b_color( -1 );    

    return( ret );
}


int rel_xybrc_printf(int x, int y, int c, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    rel_xy(x, y);
    br_color(c);
    ret = vprintf(format, argptr);
    va_end(argptr);
	br_color( -1 );

    return( ret );
}


int rel_xy_fprintf(int x, int y, FILE *fp, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    rel_xy(x, y);
    ret = vfprintf(fp, format, argptr);
    va_end(argptr);
    
    return( ret );
}


int rel_xyc_fprintf(int x, int y, int c, FILE *fp, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    rel_xy(x, y);
    color(c);
    ret = vfprintf(fp, format, argptr);
    va_end(argptr);
	color( -1 );

    return( ret );
}


int rel_xyrc_fprintf(int x, int y, int c, FILE *fp, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    rel_xy(x, y);
    r_color(c);
    ret = vfprintf(fp, format, argptr);
    va_end(argptr);
    r_color(-1);
    
    return( ret );
}


int rel_xybc_fprintf(int x, int y, int c, FILE *fp, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    xy(x, y);
    b_color(c);
    ret = vfprintf(fp, format, argptr);
    va_end(argptr);
	b_color(-1);

    return( ret );
}


int rel_xybrc_fprintf(int x, int y, int c, FILE *fp, char *format, ...)
{
    int ret;
    va_list argptr;
    
    va_start(argptr, format);
    xy(x, y);
    br_color(c);
    ret = vfprintf(fp, format, argptr);
    va_end(argptr);
    br_color(-1);

    return( ret );
}


/*	AlȂǂZ^Oĕ\B	
	gpɓẮACENTERIN.DOC QƂ̂ƁB	*/

int centering_cprintf(int dc, int c, char *format, ...)
{
	char	buf[512];
	int		x, y;
	int		keta;
	int		ret;
	va_list	argptr;
	
	va_start(argptr, format);
	vsprintf(buf, format, argptr);
	
	color(dc);
	right(32767);
	cursor_report(&keta, &y);
	
	x = (keta - strlen(buf)) / 2;
	left(32767);
	color(c);
	ret = rel_xy_printf(x, 0, buf);
	va_end(argptr);
	color(-1);
	
	return ret;
}


/*	AlȂǂZ^Oĕ\B	
	gpɓẮACENTERIN.DOC QƂ̂ƁB	*/

int centering_cfprintf(int dc, int c, FILE *fp, char *format, ...)
{
	char	buf[512];
	int		x, y;
	int		keta;
	int		ret;
	va_list	argptr;
	
	va_start(argptr, format);
	vsprintf(buf, format, argptr);
	
	color(dc);
	right(32767);
	cursor_report(&keta, &y);
	
	x = (keta - strlen(buf)) / 2;
	left(32767);
	color(c);
	ret = rel_xy_fprintf(x, 0, fp, buf);
	va_end(argptr);
	color(-1);
	
	return ret;
}


/*	J[\ʒuÃR\[͌ĂяoŒm点B
	̌` ESC [pl;pcR łBpl = line, pc = colomnB  */

int cursor_report(int *x, int *y)
{
	char	buf[LEN];
	
	
	printf("%c[6n", ESC);
	fgets(buf, LEN, stdin);
	sscanf(buf, "%d;%dR", y, x);
	
	
	return 0;
}


int c_puts(int c, char *str)
{
	color(c);
	return puts(str);
	
}


int bc_puts(int c, char *str)
{
	b_color(c);
	return puts(str);
	
}


int rc_puts(int c, char *str)
{
	r_color(c);
	return puts(str);
	
}


int brc_puts(int c, char *str)
{
	br_color(c);
	return puts(str);
	
}


int x_puts(int x, char *str)
{
	left(SCR_END);
	right(x);
	return puts(str);
}


int y_puts(int y, char *str)
{
	up_no_scroll(SCR_END);
	down(y);
	return puts(str);
}

int xc_puts(int x, int c, char *str)
{
	left(SCR_END);
	right(x);
	color(c);
	return puts(str);
}


int yc_puts(int y, int c, char *str)
{
	up_no_scroll(SCR_END);
	down(y);
	color(c);
	return puts(str);
	
}


int xy_puts(int x, int y, char *str)
{
	xy(x, y);
	return puts(str);
}


int first_last_nl_chk(char *format, char *first_nl, char *new_format, char *last_nl)
{
  size_t first_i;
  size_t last_i;
  size_t idx;
  int idx2;

  strcpy(first_nl, "");
  strcpy(new_format, "");
  strcpy(last_nl, "");


  for(first_i = 0; first_i < strlen(format); first_i++){
    if( *(format + first_i) == '\n' ){
      *(first_nl + first_i) = '\n';
    }else{
      break;
    }
  }
  *(first_nl + first_i) = '\0';
  

  idx = 0;
  for(last_i = (strlen(format) - 1); last_i > first_i; last_i--){
    if( *(format + last_i) == '\n'){
      *(last_nl + idx) = '\n';
      idx++;
    }else{
      break;
    }
  }
  *(last_nl + idx) = '\0';

  idx2 = 0;
  for(idx = first_i; idx <= last_i; idx++){
    *(new_format + idx2) = *(format + idx);
    idx2++;
  }
  *(new_format + idx2) = '\0';


  return EXIT_SUCCESS;
}


int br_printf(int rc, char *format, ...)
{
  int ret;
  va_list argptr;
  char new_format[FORMAT_BUF_LEN];
  char first_nl[FORMAT_BUF_LEN];
  char last_nl[FORMAT_BUF_LEN];
  

  va_start(argptr, format);
  first_last_nl_chk(format, first_nl, new_format, last_nl);
  
  
  br(-1);
  printf(jcode_local(first_nl));

  
  br(rc);
  ret = vprintf(jcode_local(new_format), argptr);
  
  br(-1);
  printf(jcode_local(last_nl));
  
  va_end(argptr);
  br(-1);
  
  return( ret );
}


char *br(int rc)
{
  static char *str;

  str = malloc(sizeof(char) * 128);
  if(str == NULL){
    printf("%s: %d: Can't allocate memory!\n", __FILE__, __LINE__);
    exit(EXIT_FAILURE);
  }

  
#ifdef OSX
  switch(rc){
  case   -1:
    sprintf(str, "\%c[m", ESC); /*  K̑ɖ߂*/
    break;

  case    0x00:
    sprintf(str, "\%c[40m", ESC); /*    */ 
    break;

  case    0x01:
    sprintf(str, "\%c[44m", ESC); /*    */
    break;

  case    0x02:
    sprintf(str, "\%c[41m", ESC); /*    */
    break;

  case    0x03:
    sprintf(str, "\%c[45m", ESC); /*    */
    break;

  case    0x04:
    sprintf(str, "\%c[42m", ESC); /*    */
    break;

  case    0x05:
    sprintf(str, "\%c[46m", ESC); /*  F*/
    break;

  case    0x06:
    sprintf(str, "\%c[43m", ESC); /*  F*/
    break;

  case    0x07:
    sprintf(str, "\%c[47m", ESC); /*    */
    break;

  case    0x08:
    sprintf(str, "\%c[47m", ESC); /*  邢F  */
    break;

  case    0x09:
    sprintf(str, "\%c[47m", ESC); /*  DF  */
    break;

    
  default  :
    sprintf(str, "\%c[m", ESC); /*  K̑ɖ߂*/
    break;

  }
  
#else
  switch(rc){
  case   -1:
    sprintf(str, "\%c[m", ESC); /*  K̑ɖ߂*/
    break;

  case    0x00:
    sprintf(str, "\%c[40m", ESC); /*    */
    break;

  case    0x01:
    sprintf(str, "\%c[5;44m", ESC); /*    */
    break;

  case    0x02:
    sprintf(str, "\%c[5;41m", ESC); /*    */
    break;

  case    0x03:
    sprintf(str, "\%c[5;45m", ESC); /*    */
    break;

  case    0x04:
    sprintf(str, "\%c[5;42m", ESC); /*    */
    break;

  case    0x05:
    sprintf(str, "\%c[5;46m", ESC); /*  F*/
    break;

  case    0x06:
    sprintf(str, "\%c[5;43m", ESC); /*  F*/
    break;

  case    0x07:
    sprintf(str, "\%c[5;47m", ESC); /*    */
    break;

  case    0x08:
    sprintf(str, "\%c[47m", ESC); /*  邢F  */
    break;

  case    0x09:
    sprintf(str, "\%c[5;40m", ESC); /*  DF  */
    break;

  case    0x11:
    sprintf(str, "\%c[44m", ESC); /*  Â  */
    break;

  case    0x12:
    sprintf(str, "\%c[41m", ESC); /*  Â  */
    break;

  case    0x13:
    sprintf(str, "\%c[45m", ESC); /*  Â  */
    break;

  case    0x14:
    sprintf(str, "\%c[42m", ESC); /*  Â  */
    break;

  case    0x15:
    sprintf(str, "\%c[46m", ESC); /*  ÂF*/
    break;

  case    0x16:
    sprintf(str, "\%c[43m", ESC); /*  ÂF*/
    break;

  case    0x17:
    sprintf(str, "\%c[47m", ESC); /*  ÂF*/
    break;

    
  default  :
    sprintf(str, "\%c[m", ESC); /*  K̑ɖ߂*/
    break;

  }
#endif

  printf("%s", str);
  return str;

}


int wc_printf(int c, char *format, ...)
{
  int ret;
  va_list argptr;
  char new_format[FORMAT_BUF_LEN];
  char first_nl[FORMAT_BUF_LEN];
  char last_nl[FORMAT_BUF_LEN];
  

  va_start(argptr, format);
  first_last_nl_chk(format, first_nl, new_format, last_nl);
  
  
  wc(-1);
  printf(jcode_local(first_nl));
  
  wc(c);
  ret = vprintf(jcode_local(new_format), argptr);
  
  wc(-1);
  printf(jcode_local(last_nl));
  
  va_end(argptr);
  wc(-1);
  
  return( ret );
}


char *wc(int c)
{
  static char *str;

  str = malloc(sizeof(char) * 128);
  if(str == NULL){
    printf("%s: %d: Can't allocate memory!\n", __FILE__, __LINE__);
    exit(EXIT_FAILURE);
  }

  
#ifdef OSX
  switch(c){
  case   -1:
    sprintf(str, "\%c[m", ESC); /*  K̑ɖ߂*/
    break;

  case    0x00:
    sprintf(str, "\%c[7;30m", ESC); /*    */
    break;

  case    0x01:
    sprintf(str, "\%c[7;34m", ESC); /*    */
    break;

  case    0x02:
    sprintf(str, "\%c[7;31m", ESC); /*    */
    break;

  case    0x03:
    sprintf(str, "\%c[7;35m", ESC); /*    */
    break;

  case    0x04:
    sprintf(str, "\%c[7;32m", ESC); /*    */
    break;

  case    0x05:
    sprintf(str, "\%c[7;36m", ESC); /*  F*/
    break;

  case    0x06:
    sprintf(str, "\%c[7;33m", ESC); /*  F*/
    break;

  case    0x07:
    sprintf(str, "\%c[7;37m", ESC); /*    */
    break;

  case    0x08:
    sprintf(str, "\%c[7;37m", ESC); /*  邢F  */
    break;

  case    0x09:
    sprintf(str, "\%c[7;37m", ESC); /*  DF  */
    break;

  default  :
    sprintf(str, "\%c[m", ESC); /*  K̑ɖ߂*/
    break;

  }

#else

  switch(c){
  case   -1:
    sprintf(str, "\%c[m", ESC); /*  K̑ɖ߂*/
    break;

  case    0x00:
    sprintf(str, "\%c[7;30m", ESC); /*    */
    break;

  case    0x01:
    sprintf(str, "\%c[5;7;34m", ESC); /*    */
    break;

  case    0x02:
    sprintf(str, "\%c[5;7;31m", ESC); /*    */
    break;

  case    0x03:
    sprintf(str, "\%c[5;7;35m", ESC); /*    */
    break;

  case    0x04:
    sprintf(str, "\%c[5;7;32m", ESC); /*    */
    break;

  case    0x05:
    sprintf(str, "\%c[5;7;36m", ESC); /*  F*/
    break;

  case    0x06:
    sprintf(str, "\%c[5;7;33m", ESC); /*  F*/
    break;

  case    0x07:
    sprintf(str, "\%c[5;7;37m", ESC); /*    */
    break;

  case    0x08:
    sprintf(str, "\%c[7;37m", ESC); /*  邢F  */
    break;

  case    0x09:
    sprintf(str, "\%c[5;7;38m", ESC); /*  DF  */
    break;

  default  :
    sprintf(str, "\%c[m", ESC); /*  K̑ɖ߂*/
    break;

  }
#endif

  printf("%s", str);
  return str;

}

int rel_xy_br_printf(int x, int y, int rc, char *format, ...)
{
  int ret;
  va_list argptr;
  char new_format[FORMAT_BUF_LEN];
  char first_nl[FORMAT_BUF_LEN];
  char last_nl[FORMAT_BUF_LEN];


  va_start(argptr, format);
  first_last_nl_chk(format, first_nl, new_format, last_nl);
  
  rel_xy(x, y);
  
  br(-1);
  printf(jcode_local(first_nl));
  
  br(rc);
  ret = vprintf(jcode_local(new_format), argptr);

  br(-1);
  printf(jcode_local(last_nl));
  
  va_end(argptr);
  br(-1);
  
  return( ret );
}


int rel_y_br_printf(int y, int rc, char *format, ...)
{
  int ret;
  va_list argptr;
  char new_format[FORMAT_BUF_LEN];
  char first_nl[FORMAT_BUF_LEN];
  char last_nl[FORMAT_BUF_LEN];

  va_start(argptr, format);
  first_last_nl_chk(format, first_nl, new_format, last_nl);
  
  rel_y(y);

  br(-1);
  printf(jcode_local(first_nl));
  
  br(rc);
  ret = vprintf(jcode_local(new_format), argptr);

  br(-1);
  printf(jcode_local(last_nl));
  
  va_end(argptr);
  br(-1);
  
  return( ret );
}


/*
ƍt
Mac 30 
Cyg 30 
Cyg: 31-36 ÂOiF
Mac: 31-36 ÂOiF
Mac 37 
Cyg 37 
Mac 40 
Cyg 40 W
Cyg 41-46 ÂwiF
Mac 41-46 邢wiF
Mac 47 
Cyg 47 
Mac 7;30 DF wi
Mac 7;31 - 7;36 邢wiF
Cyg 7;31 F wi
Cyg 7;32 F wi
Cyg 7;33 F wiȂ
Cyg 7;34 F wi
Cyg 7;35 F wisN
Cyg 7;36 F wiF
Mac 7;37 OiwiW

Mac 7;38  wi
Mac 7;39 W wi
Mac 7;40 Oiwi

Cyg 7;30 F wiDF
Cyg 7;37 F wi
Cyg 7;38 F wi
Cyg 7;39 F wi
*/
