/*  Time-stamp: <2005-03-28 13:08:08 >  */
#include  "4ru.h"
#include  "GLcolors.h"

extern xmlDoc *xml_doc_top;

extern xmlDoc *gpr_doc_top;
extern xmlNode *gpr_top;



double disp_gpr_group(xmlNode *group_top, double Lbot, int level, NOTE_NODE **s_note_node, NOTE_NODE **e_note_node)
{
  xmlNode *group_cur = NULL;
  xmlNode *group_note = NULL;
  char s_note_id[STR_LEN] = "";
  char e_note_id[STR_LEN] = "";
  NOTE_NODE *g_s_note_node = NULL;
  NOTE_NODE *g_e_note_node = NULL;
  xmlNode *s_xml_node = NULL;
  xmlNode *e_xml_node = NULL;
  double rule_y = 0;
  double last_x = 0;
  char str_tmp[STR_LEN];


  group_cur = group_top;


  while(1){
    if(group_cur == NULL){  break; }
    if(group_cur->type != XML_ELEMENT_NODE){
      group_cur = group_cur->next;
      continue;
    }

    if(strcmp(group_cur->name, "note") == 0){
      group_note = group_cur;
      strcpy(s_note_id, xmlGetProp(group_note, "id"));
      group_note = group_note->next;
      while(1){
	if(group_note == NULL){  break; }
	if(strcmp(group_note->name, "note") == 0){
	  strcpy(e_note_id, xmlGetProp(group_note, "id"));
	}
	group_note = group_note->next;
      }
/*       puts("------ start ------"); */
/*       printf("s: %s\n", s_note_id); */
/*       printf("e: %s\n", e_note_id); */
/*       puts("------ end ------"); */

      get_node_xml_id(s_note_id, &s_xml_node, s_note_node);
      get_node_xml_id(e_note_id, &e_xml_node, e_note_node);

      draw_gpr_line((*s_note_node), (*e_note_node), Lbot, level, -1.0);
      if(*s_note_node != NULL){
	last_x = (*e_note_node)->draw_xe;
      }
      return last_x;
    }else if(strcmp(group_cur->name, "group") == 0){
      last_x = disp_gpr_group(group_cur->children, Lbot, level + 1, s_note_node, e_note_node);
      if(g_s_note_node == NULL){  g_s_note_node = (*s_note_node);  }
      g_e_note_node = (*e_note_node);
      rule_y = 0;
    }else if(strcmp(group_cur->name, "applied") == 0){
      sprintf(str_tmp, "%d:", level + 1);
      put_str(last_x + 2, Lbot - GPR_LINE_BIAS + ((level + 1) * GPR_LINE_INTER) - (rule_y * 12) + 2, 0, 
	  OpenGLcolors[1], str_tmp);
      put_str(-1, -1, -1, OpenGLcolors[2], xmlGetProp(group_cur, "rule"));
      rule_y++;
    }
    group_cur = group_cur->next;
  }


  if(level > 0){
    draw_gpr_line(g_s_note_node, g_e_note_node, Lbot, level, -1.0);
  }

  (*s_note_node) = g_s_note_node;
  (*e_note_node) = g_e_note_node;

  return last_x;

}
