/*  Time-stamp: <2004-09-14 11:32:00 >  */
#include  "4ru.h"
#include  "date.h"


xmlNode *gen_MusicXML_header(xmlNode **xml_top, NOTE_NODE *note_top, NOTE_HEADER *note_header_info)
{
  xmlNode *xml_cur = NULL;
  xmlNode *xml_part_list = NULL;
  xmlNode *xml_ident = NULL;
  xmlNode *xml_encoding = NULL;
  xmlNode *xml_score_part = NULL;
  xmlNode *xml_midi_instrument = NULL;
  xmlChar *title = NULL;
  xmlChar *composer = NULL;
  int year;
  int month;
  int day;
  char str_tmp[STR_LEN];

  /*  Warning к  */
  note_top = note_top;
  /*  Warning кޤ  */


  if(note_header_info->title != NULL){
    title = note_header_info->title;
  }else{
    title = NULL;
  }
  xml_cur = xmlNewChild(*xml_top, NULL, BAD_CAST "movement-title", title);

  xml_ident = xmlNewChild(*xml_top, NULL, BAD_CAST "identification", NULL);

  if(note_header_info->composer != NULL){
    composer = note_header_info->composer;
  }else{
    composer = NULL;
  }

  xml_cur = xmlNewChild(xml_ident, NULL, BAD_CAST "creator", composer);
  xmlNewProp(xml_cur, BAD_CAST "type", BAD_CAST "composer");

  xml_encoding = xmlNewChild(xml_ident, NULL, BAD_CAST "encoding", NULL);
  sprintf(str_tmp, "4Ru Ver.%s %s", _4RuVER, DATE);
  xml_cur = xmlNewChild(xml_encoding, NULL, BAD_CAST "software", str_tmp);

  get_today(&year, &month, &day);
  sprintf(str_tmp, "%d-%02d-%02d", year, month, day);
  xml_cur = xmlNewChild(xml_encoding, NULL, BAD_CAST "encoding-date", BAD_CAST str_tmp);


  /*  part-list   */
  xml_part_list = xmlNewChild(*xml_top, NULL, BAD_CAST "part-list", NULL);
  xml_score_part = xmlNewChild(xml_part_list, NULL, BAD_CAST "score-part", NULL);
  xmlNewProp(xml_score_part, BAD_CAST "id", BAD_CAST "P1");

  xml_cur = xmlNewChild(xml_score_part, NULL, BAD_CAST "part-name", "Piano");
  xml_cur = xmlNewChild(xml_score_part, NULL, BAD_CAST "score-instrument", NULL);
  xmlNewProp(xml_cur, BAD_CAST "id", BAD_CAST "P1-I1");
  xml_cur = xmlNewChild(xml_cur, NULL, BAD_CAST "instrument-name", "Acoustic Grand Piano");

  xml_midi_instrument = xmlNewChild(xml_score_part, NULL, BAD_CAST "midi-instrument", NULL);
  xmlNewProp(xml_midi_instrument, BAD_CAST "id", BAD_CAST "P1-I1");

  xml_cur = xmlNewChild(xml_midi_instrument, NULL, BAD_CAST "midi-channel", "1");
  xml_cur = xmlNewChild(xml_midi_instrument, NULL, BAD_CAST "midi-program", "1");


  return xml_cur;

}
