#include  "4ru.h"


extern NOTE_NODE *note_bot;
extern int win_w;


int gpr2b(NOTE_NODE *linetop)
{
  NOTE_NODE *cur;
  NOTE_NODE *n[4];
  double ioi23;
  double ioi12;
  double ioi34;

  double ioi_r23;
  double ioi_r12;
  double ioi_r34;

  double ioi12_bias = 0.0;
  double ioi34_bias = 0.0;
  double lenrest2;


/*   double ioi_r12_bias = 0.0; */
/*   double ioi_r34_bias = 0.0; */




  cur = linetop;
  while(1){
    if(cur->draw_xs >= (win_w + 128) ){  return  EXIT_SUCCESS; }
/*     t12_bias = 0.0; */
/*     t34_bias = 0.0; */

    if(get_n4(cur, n, -1) == EXIT_FAILURE){  return  EXIT_SUCCESS;  }
    /*
      n1 : n[0]
      n2 : n[1]
      n3 : n[2]
      n4 : n[3]
    */
    ioi23 =
      (n[2]->on_time.beat + n[2]->on_diff.beat) - 
      (n[1]->on_time.beat + n[1]->on_diff.beat);
    ioi12 =
      (n[1]->on_time.beat + n[1]->on_diff.beat) -
      (n[0]->on_time.beat + n[0]->on_diff.beat);
    ioi34 =
      (n[3]->on_time.beat + n[3]->on_diff.beat) -
      (n[2]->on_time.beat + n[2]->on_diff.beat);

    ioi_r23 = ioi23 / n[1]->len.beat;
    ioi_r12 = ioi12 / n[0]->len.beat;
    ioi_r34 = ioi23 / n[1]->len.beat;
    
    lenrest2 = get_lenrest(n[1], n[2]);

    
    n[1]->GPR[GPR2b] = ((ioi23 - ioi12) + (ioi23 - ioi34)) / lenrest2;
/*     n[1]->GPR[GPR2b] = ((ioi23 / ioi12) - 1.0) + ((ioi23 / ioi34) - 1.0); */

    if( ( (ioi23 >= 0.0) &&
	  (ioi23 > (ioi12 + ioi12_bias)) && (ioi23 > (ioi34 + ioi34_bias))) ){
      n[1]->GPR_ON_OFF[GPR2b] = ON;
    }else{
      n[1]->GPR_ON_OFF[GPR2b] = OFF;
    }

    if(n[1]->org_node != NULL){
      n[1]->org_node->GPR[GPR2b] = n[1]->GPR[GPR2b];
      n[1]->org_node->GPR_ON_OFF[GPR2b] = n[1]->GPR_ON_OFF[GPR2b];
    }

    cur = cur->next;
  }

  return  EXIT_SUCCESS;
}
