#include  "NOTEfile.h"
#include  "disp_errline.h"


int note_timescale_parse(FILE *fp, char *filename,
			 int line, char linebuf[], int *idx, char token[],
			 NOTE_HEADER *header_info, NOTE_NODE *cur)
{
  char err_mesg[READBUF_LEN];

  cur = cur;


  get_token(linebuf, idx, token);  /*  ʸɤФ  */
  get_token(linebuf, idx, token);
  if(stricmp(token, "Beat") == 0){
    header_info->timescale = T_BEAT;
  }else if(stricmp(token, "Real") == 0){
    header_info->timescale = T_REAL;
  }else if(stricmp(token, "Meas") == 0){
    header_info->timescale = T_MEAS;
  }else if(stricmp(token, "Delta") == 0){
    header_info->timescale = T_DELTA;
    get_token(linebuf, idx, token);  /*  ʸɤФ  */
    get_token(linebuf, idx, token);
    if(sscanf(token, "%d", &(header_info->timescale_divi)) != 1){
      sprintf(err_mesg, "TIMESCALE Delta λʬǽͤꤵƤʤ (%s)", token);
      disp_errline(filename, line, linebuf, *idx, err_mesg);
      fclose(fp);
      exit(EXIT_FAILURE);
    }
  }

  get_token(linebuf, idx, token);


  /*
  printf("\ntimescale: %d\n", header_info->timescale);
  */

  return EXIT_SUCCESS;
}
