/*  Time-stamp: <2005-05-27 16:58:12 >  */
#include  "4ru.h"
#include  <glut.h>
#include  "jcode.h"

extern int win_w;
extern int win_h;
extern double alpha;
extern int win_id;
extern char prog_name[STR_LEN];


int nov_init(int *argcp, char *argv[], char *filename, char *add_title_str)
{
  static char nov_title[STR_LEN];
  static char *from_enc = "SHIFT-JIS";
/*   static char *to_enc = "UTF-8"; */
  static char *to_enc = "SHIFT-JIS";

  glutInit(argcp, argv);
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
  glutInitWindowSize(win_w, win_h);
  glutInitWindowPosition(0, 0);
  if(strnicmp(prog_name, "PopE", 4) == 0){
    sprintf(nov_title, "PopE - %s", filename);
  }else{
    sprintf(nov_title, "%s", filename);
  }

  if(iconv_if(add_title_str, to_enc, from_enc) != NULL){
    strcat(nov_title, iconv_if(add_title_str, to_enc, from_enc));
  }

  win_id = glutCreateWindow(nov_title);

  glClearColor(1.0, 1.0, 1.0, 1.0);   /*  Background color  */
  glColor4d(0.0, 0.0, 0.0, 1.0);           /*  Foreground color  */

  glViewport(0, 0, win_w, win_h);
  glEnable(GL_LINE_STIPPLE);
  glEnable(GL_LINE_SMOOTH);
  glEnableClientState(GL_COLOR_ARRAY);
  glEnableClientState(GL_VERTEX_ARRAY);
  glEnable(GL_BLEND);
  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

  glutMouseFunc(search_event);
  glutMotionFunc(mouse_move);

  make_menu();

  glRenderMode(GL_RENDER);
  glInitNames();
  glPushName(0);

  glClear(GL_COLOR_BUFFER_BIT);

  set_gosen_colors();

  glutDisplayFunc(re_draw);  /*  $BIA2h%k!<%A%s(B  */
  glutReshapeFunc(resize);   /*  $B%j%5%$%:;~@_Dj%k!<%A%s(B  */
  glutKeyboardFunc(key_switcher);  /*  $B%-!<F~NO=hM}%k!<%A%s(B  */
  glutSpecialFunc(Skey_switcher);

/*   glFlush(); */
  glutSwapBuffers();

  glutMainLoop();

  return  EXIT_SUCCESS;
}
